Index: pjproject/branches/projects/2.0-dev/aconfigure.ac
===================================================================
--- pjproject/branches/projects/2.0-dev/aconfigure.ac	(revision 3642)
+++ pjproject/branches/projects/2.0-dev/aconfigure.ac	(revision 3643)
@@ -407,4 +407,7 @@
 	ac_os_objs="$ac_os_objs file_access_win32.o file_io_win32.o os_core_win32.o os_error_win32.o os_time_win32.o os_timestamp_win32.o guid_win32.o"
 	;;
+  *darwin*)
+	ac_os_objs="$ac_os_objs os_core_darwin.o"
+	;;
   *)
 	ac_os_objs="$ac_os_objs file_access_unistd.o file_io_ansi.o os_core_unix.o os_error_unix.o os_time_unix.o os_timestamp_posix.o"
Index: pjproject/branches/projects/2.0-dev/pjlib/include/pj/os.h
===================================================================
--- pjproject/branches/projects/2.0-dev/pjlib/include/pj/os.h	(revision 3642)
+++ pjproject/branches/projects/2.0-dev/pjlib/include/pj/os.h	(revision 3643)
@@ -1332,4 +1332,34 @@
 /* **************************************************************************/
 /**
+ * @defgroup PJ_APP_OS Application execution
+ * @ingroup PJ_OS
+ * @{
+ */
+
+/* Type for main function. */
+typedef int (*pj_main_func_ptr)(int argc, char *argv[]);
+
+/**
+ * Run the application. This function has to be called in the main thread
+ * and after doing the necessary initialization according to the flags
+ * provided, it will call main_func() function.
+ *
+ * @param main_func Application's main function.
+ * @param argc	    Number of arguments from the main() function, which
+ * 		    will be passed to main_func() function.
+ * @param argv	    The arguments from the main() function, which will
+ * 		    be passed to main_func() function.
+ * @param flags     Flags for application execution, currently must be 0.
+ *
+ * @return          main_func()'s return value.
+ */
+int pj_run_app(pj_main_func_ptr main_func, int argc, char *argv[],
+	       unsigned flags);
+
+/** @} */
+
+
+/* **************************************************************************/
+/**
  * Internal PJLIB function to initialize the threading subsystem.
  * @return          PJ_SUCCESS or the appropriate error code.
Index: pjproject/branches/projects/2.0-dev/pjlib/src/pj/os_core_darwin.m
===================================================================
--- pjproject/branches/projects/2.0-dev/pjlib/src/pj/os_core_darwin.m	(revision 3643)
+++ pjproject/branches/projects/2.0-dev/pjlib/src/pj/os_core_darwin.m	(revision 3643)
@@ -0,0 +1,86 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2011-2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#include <pj/os.h>
+#include <pthread.h>
+#include <AppKit/AppKit.h>
+#include <CoreFoundation/CFRunLoop.h>
+#include <Foundation/Foundation.h>
+
+#define THIS_FILE   "os_core_darwin.m"
+
+typedef struct run_app_t {
+    pj_main_func_ptr  main_func;
+    int               argc;
+    char            **argv;
+    int               retval;
+} run_app_t;
+
+@interface DeadThread: NSObject { ;; }
++ (void)enterMultiThreadedMode;
++ (void)emptyThreadMethod:(id)obj;
+@end
+
+@implementation DeadThread
++ (void)enterMultiThreadedMode
+{
+    [NSThread detachNewThreadSelector:@selector(emptyThreadMethod:)
+              toTarget:[DeadThread class] withObject:nil];
+}
+
++ (void)emptyThreadMethod:(id)obj { ; }
+@end
+
+static void* main_thread(void *data)
+{
+    run_app_t *param = (run_app_t *)data;
+    
+    param->retval = (*param->main_func)(param->argc, param->argv);
+    CFRunLoopStop(CFRunLoopGetMain());
+    
+    return NULL;
+}
+
+/*
+ * pj_run_app()
+ * This function has to be called from the main thread. The purpose of
+ * this function is to initialize the application's memory pool, event
+ * loop management, and multi-threading environment.
+ */
+PJ_DEF(int) pj_run_app(pj_main_func_ptr main_func, int argc, char *argv[],
+                       unsigned flags)
+{
+    pthread_t thread;
+    run_app_t param;
+    NSAutoreleasePool *pool;
+    
+    pool = [[NSAutoreleasePool alloc] init];
+    [NSApplication sharedApplication];
+    [DeadThread enterMultiThreadedMode];
+
+    param.argc = argc;
+    param.argv = (char **)argv;
+    param.main_func = main_func;
+    if (pthread_create(&thread, NULL, &main_thread, &param) == 0) {
+        CFRunLoopRun();
+    }
+    
+    PJ_UNUSED_ARG(pool);
+    
+    return param.retval;
+}
Index: pjproject/branches/projects/2.0-dev/pjlib/src/pj/os_core_symbian.cpp
===================================================================
--- pjproject/branches/projects/2.0-dev/pjlib/src/pj/os_core_symbian.cpp	(revision 3642)
+++ pjproject/branches/projects/2.0-dev/pjlib/src/pj/os_core_symbian.cpp	(revision 3643)
@@ -1037,2 +1037,11 @@
 
 #endif	/* PJ_OS_HAS_CHECK_STACK */
+
+/*
+ * pj_run_app()
+ */
+PJ_DEF(int) pj_run_app(pj_main_func_ptr main_func, int argc, char *argv[],
+                       unsigned flags)
+{
+    return (*main_func)(argc, argv);
+}
Index: pjproject/branches/projects/2.0-dev/pjlib/src/pj/os_core_unix.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjlib/src/pj/os_core_unix.c	(revision 3642)
+++ pjproject/branches/projects/2.0-dev/pjlib/src/pj/os_core_unix.c	(revision 3643)
@@ -1823,2 +1823,10 @@
 #endif	/* PJ_TERM_HAS_COLOR */
 
+/*
+ * pj_run_app()
+ */
+PJ_DEF(int) pj_run_app(pj_main_func_ptr main_func, int argc, char *argv[],
+                       unsigned flags)
+{
+    return (*main_func)(argc, argv);
+}
Index: pjproject/branches/projects/2.0-dev/pjlib/src/pj/os_core_win32.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjlib/src/pj/os_core_win32.c	(revision 3642)
+++ pjproject/branches/projects/2.0-dev/pjlib/src/pj/os_core_win32.c	(revision 3643)
@@ -1422,2 +1422,11 @@
 
 #endif	/* PJ_TERM_HAS_COLOR */
+
+/*
+ * pj_run_app()
+ */
+PJ_DEF(int) pj_run_app(pj_main_func_ptr main_func, int argc, char *argv[],
+                       unsigned flags)
+{
+    return (*main_func)(argc, argv);
+}
Index: pjproject/branches/projects/2.0-dev/pjmedia/build/Makefile
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/build/Makefile	(revision 3642)
+++ pjproject/branches/projects/2.0-dev/pjmedia/build/Makefile	(revision 3643)
@@ -123,5 +123,6 @@
 export PJMEDIA_TEST_SRCDIR = ../src/test
 export PJMEDIA_TEST_OBJS += codec_vectors.o jbuf_test.o main.o mips_test.o \
-			    vid_codec_test.o vid_dev_test.o rtp_test.o test.o
+			    vid_codec_test.o vid_dev_test.o vid_port_test.o \
+			    rtp_test.o test.o
 export PJMEDIA_TEST_OBJS += sdp_neg_test.o 
 export PJMEDIA_TEST_CFLAGS += $(_CFLAGS)
Index: pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia_videodev.h
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia_videodev.h	(revision 3642)
+++ pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia_videodev.h	(revision 3643)
@@ -28,9 +28,3 @@
 #include <pjmedia-videodev/videodev_imp.h>
 
-#if defined(PJ_DARWINOS) && PJ_DARWINOS!=0
-#   if PJMEDIA_VIDEO_DEV_HAS_SDL
-#	include <SDL.h>
-#endif
-#endif
-
 #endif	/* __PJMEDIA_VIDEODEV_H__ */
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/test/main.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/test/main.c	(revision 3642)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/test/main.c	(revision 3643)
@@ -18,6 +18,7 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
  */
+#include <pj/os.h>
+
 #include "test.h"
-#include <pjmedia_videodev.h>
 
  
@@ -31,6 +32,5 @@
 #endif
 
-
-int main(int argc, char *argv[])
+static int main_func(int argc, char *argv[])
 {
     int rc;
@@ -48,3 +48,6 @@
 }
 
-
+int main(int argc, char *argv[])
+{
+    return pj_run_app(&main_func, argc, argv, 0);
+}
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/test/test.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/test/test.c	(revision 3642)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/test/test.c	(revision 3643)
@@ -20,8 +20,4 @@
 #include "test.h"
 
-#if defined(PJ_DARWINOS) && PJ_DARWINOS!=0
-#   include <CoreFoundation/CFRunLoop.h>
-#endif
-
 #define THIS_FILE   "test.c"
 
@@ -37,8 +33,5 @@
 
 pj_pool_factory *mem;
-pj_bool_t is_quit = PJ_FALSE;
-pj_thread_t *thread;
-pj_caching_pool caching_pool;
-pj_pool_t *pool;
+
 
 void app_perror(pj_status_t status, const char *msg)
@@ -51,7 +44,22 @@
 }
 
-static int test_func(void *data)
+int test_main(void)
 {
     int rc = 0;
+    pj_caching_pool caching_pool;
+    pj_pool_t *pool;
+
+    pj_init();
+    pj_caching_pool_init(&caching_pool, &pj_pool_factory_default_policy, 0);
+    pool = pj_pool_create(&caching_pool.factory, "test", 1000, 512, NULL);
+
+    pj_log_set_decor(PJ_LOG_HAS_NEWLINE);
+    pj_log_set_level(3);
+
+    mem = &caching_pool.factory;
+
+    pjmedia_video_format_mgr_create(pool, 64, 0, NULL);
+    pjmedia_converter_mgr_create(pool, NULL);
+    pjmedia_vid_codec_mgr_create(pool, NULL);
 
 #if HAS_VID_PORT_TEST
@@ -62,9 +70,9 @@
     DO_TEST(vid_dev_test());
 #endif
-    
+
 #if HAS_VID_CODEC_TEST
     DO_TEST(vid_codec_test());
 #endif
-    
+
 #if HAS_SDP_NEG_TEST
     DO_TEST(sdp_neg_test());
@@ -82,7 +90,7 @@
     DO_TEST(codec_test_vectors());
 #endif
-    
+
     PJ_LOG(3,(THIS_FILE," "));
-    
+
 on_return:
     if (rc != 0) {
@@ -91,39 +99,4 @@
 	PJ_LOG(3,(THIS_FILE,"Looks like everything is okay!"));
     }
-    
-    is_quit = PJ_TRUE;
-    return rc;
-}
-
-int test_main(void)
-{
-    int rc = 0;
-
-    pj_init();
-    pj_caching_pool_init(&caching_pool, &pj_pool_factory_default_policy, 0);
-    pool = pj_pool_create(&caching_pool.factory, "test", 1000, 512, NULL);
-    
-    pj_log_set_decor(PJ_LOG_HAS_NEWLINE);
-    pj_log_set_level(3);
-
-    mem = &caching_pool.factory;
-
-    pjmedia_video_format_mgr_create(pool, 64, 0, NULL);
-    pjmedia_converter_mgr_create(pool, NULL);
-    pjmedia_vid_codec_mgr_create(pool, NULL);
-
-#if defined(PJ_DARWINOS) && PJ_DARWINOS!=0
-    {
-	if (pj_thread_create(pool, "test_func", test_func, NULL, 0, 0,
-			     &thread) == PJ_SUCCESS) {
-	    while (!is_quit) {
-		CFRunLoopRunInMode(kCFRunLoopDefaultMode, 0, false);
-	    }
-	}
-	return 0;
-    }
-#else
-    rc = test_func(NULL);
-#endif
 
     pjmedia_video_format_mgr_destroy(pjmedia_video_format_mgr_instance());
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/pjsua/main.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/pjsua/main.c	(revision 3642)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/pjsua/main.c	(revision 3643)
@@ -18,10 +18,6 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
  */
-#include <pjmedia_videodev.h>
 #include <pjsua-lib/pjsua.h>
 
-#if defined(PJ_DARWINOS) && PJ_DARWINOS!=0
-#   include <CoreFoundation/CFRunLoop.h>
-#endif
 
 #define THIS_FILE	"main.c"
@@ -32,5 +28,4 @@
  */
 extern pj_bool_t app_restart;
-pj_bool_t is_quit = PJ_FALSE;
 pj_status_t app_init(int argc, char *argv[]);
 pj_status_t app_main(void);
@@ -81,27 +76,5 @@
 #endif
 
-#if defined(PJ_DARWINOS) && PJ_DARWINOS!=0
-static int main_func(void *data);
-int argc;
-char **argv;
-
-int main(int argcm, char *argvm[])
-{ 
-    pthread_t thread;
-
-    argc = argcm;
-    argv = (char **)argvm;
-    if (pthread_create(&thread, NULL, &main_func, NULL) == 0) {
-	while (!is_quit) {
-	    CFRunLoopRunInMode(kCFRunLoopDefaultMode, 0, false);
-	}
-    }
-
-    return 0;
-}
-static int main_func(void *data)
-#else
-int main(int argc, char *argv[])
-#endif
+static int main_func(int argc, char *argv[])
 {
     do {
@@ -120,6 +93,9 @@
     } while (app_restart);
 
-    is_quit = PJ_TRUE;
     return 0;
 }
 
+int main(int argc, char *argv[])
+{
+    return pj_run_app(&main_func, argc, argv, 0);
+}
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/aviplay.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/aviplay.c	(revision 3642)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/aviplay.c	(revision 3643)
@@ -21,5 +21,4 @@
 #include <pjmedia/converter.h>
 #include <pjmedia-codec.h>
-#include <pjmedia_videodev.h>
 #include <pjlib-util.h>
 #include <pjlib.h>
@@ -448,8 +447,5 @@
 
 
-/*
- * main()
- */
-int main(int argc, char *argv[])
+static int main_func(int argc, char *argv[])
 {
     pj_caching_pool cp;
@@ -529,2 +525,7 @@
     return 0;
 }
+
+int main(int argc, char *argv[])
+{
+    return pj_run_app(&main_func, argc, argv, 0);
+}
